clear; close all;

%Convergence tolerance for Hard thresholding methods

uniformCut=2;    % The value can be 0, 1 and 2(for customization)
projDen=pi/180;
iniAngle=0; %pi*(90+17.5)/180
thc=(0:pi/180:pi-pi/180);
thc=[1:10, 21:100, 111:180]*pi/180-pi/180;
%290; %(260:10:360);%(31:50); % %
radialNum=155; 

% Initialize mask Dore method
mx=512;
if(uniformCut==1)
    [M,Mh,mi,mhi]=LineMask(radialNum,mx);
elseif(uniformCut==0)
    endAngle=radialNum*projDen+iniAngle;
    [M,Mh,mi,mhi]=LineMask(radialNum,mx,endAngle,iniAngle);
else
    [M,Mh,mi,mhi]=LineMask(length(thc),mx,0,0,thc);
end

close all;
N=512;
linewidth=2;
M=fftshift(reshape(M,mx,mx));
ridx=repmat((1:mx)'-mx/2-1,1,mx);
cidx=repmat((1:mx)-mx/2-1,mx,1);
dist=sqrt(ridx.^2+cidx.^2);
temp=find(dist(:)>mx/2);
M(temp)=0;
M=~M;
fh=figure; imshow(M); axis off;

set(gca,'position',[0,0,1,1]);
Width=N;
Height=N;

ang=9.5:0.05:20; %ang=ang+180;
A=N/2/1.618;
x=A*cos(ang/180*pi)+N/2+1;
y=A*sin(ang/180*pi)+N/2+1;
hold on; plot(x,y,'-r','linewidth',linewidth);
annotation(fh,'arrow',x(end-1:end)/Width-0.076,...
    (N-y(end-1:end))/Height,'LineWidth',linewidth,'Color',[1 0 0]);

ang=99.5:0.05:110.5; ang=ang+180;
A=N/2/1.618;
x=A*cos(ang/180*pi)+N/2+1;
y=A*sin(ang/180*pi)+N/2+1;
hold on; plot(x,y,'-r','linewidth',linewidth);
annotation(fh,'arrow',x(2:-1:1)/Width-0.0155,...
    (N-y(2:-1:1))/Height-0.00135,'LineWidth',linewidth,'Color',[1 0 0]);
% annotation(fh,'arrow',x(end-1:end)/Width+pos(1),...
%     (N-y(end-1:end))/Height+pos(2),'LineWidth',2,'Color',[1 0 1]);

% ang=131:0.1:179; ang=ang+180;
% A=200;
% x=A*cos(ang/180*pi)+256;
% y=A*sin(ang/180*pi)+257;
% hold on; plot(x,y,'-r','linewidth',linewidth);
% 
% annotation(fh,'arrow',x(2:-1:1)/Width+pos(1),...
%     (N-y(2:-1:1))/Height+pos(2),'LineWidth',2,'Color',[1 0 0]);
% % annotation(fh,'arrow',x(end-1:end)/Width+pos(1),...
% %     (N-y(end-1:end))/Height+pos(2),'LineWidth',2,'Color',[1 0 1]);
% 
% t=0:0.1:256;
% x=256+t*cos(310*pi/180);
% y=258+t*sin(310*pi/180);
% plot(x,y,'-r','linewidth',linewidth);

annotation(fh,'textbox',...
[0.73 0.38 0.072529411764705 0.0681063122923588],...
    'String',{'10^{\circ}'},...
    'FontSize',19,...
    'LineStyle','none',...
    'Color',[1 0 0]);
annotation(fh,'textbox',...
[0.54 0.82 0.072529411764705 0.0681063122923588],...
    'String',{'10^{\circ}'},...
    'FontSize',19,...
    'LineStyle','none',...
    'Color',[1 0 0]);

% annotation(fh,'textbox',...
%     [0.764235294117647 0.629568106312294 0.075470588235294 0.0681063122923588],...
%     'String',{'50^{\circ}'},...
%     'FontSize',19,...
%     'LineStyle','none',...
%     'Color',[1 0 0]);
% 
%%
saveas(gcf,'cut20Pattern.eps','psc2');
%!epstopdf cut20Pattern.eps

close all;

