close all
clear;
load realCTdCut20/NIHT.mat;
load realCTdCut20/maskDORE3002.mat;

x1=10; x2=60; y1=5.8e5; y2=6.12e5;
xx1=20; xx2=90; yy1=2.5e5; yy2=5.3e5;
figure; 
hold on; 
x=out_maskDORE{1}.time; y=out_maskDORE{1}.likelihood;
plot(x,y,'linewidth',2);

x=out_maskDORE{2}.time; y=out_maskDORE{2}.likelihood;
plot(x,y,'b-.','linewidth',2);

x=out_NIHT{1}.tVec(:); y=out_NIHT{1}.likelihood(:);
plot(x,y,'r--','linewidth',2);

x=out_NIHT{2}.tVec(:); y=out_NIHT{2}.likelihood(:);
plot(x,y,'r:','linewidth',2);

ylim([2e5,7e5]);
xlim([0,100]);

set(gca,'fontsize',20);
xlabel('CPU time (s)','fontname','times');
ylabel('$\mathcal{L}^{(p)}$','Interpreter','latex');
h=legend('DORE $r$=5000','DORE $r$=20000','NIHT $r$=5000','NIHT $r$=20000');
set(h,'Interpreter','latex');

x=out_maskDORE{1}.time; y=out_maskDORE{1}.likelihood;
idx=find((x>=x1)&(x<x2)&(y>=y1)&(y<y2));
plot((x(idx)-x1)*(xx2-xx1)/(x2-x1)+xx1,(y(idx)-y1)*(yy2-yy1)/(y2-y1)+yy1,'linewidth',2);

x=out_maskDORE{2}.time; y=out_maskDORE{2}.likelihood;
idx=find((x>=x1)&(x<x2)&(y>=y1)&(y<y2));
plot((x(idx)-x1)*(xx2-xx1)/(x2-x1)+xx1,(y(idx)-y1)*(yy2-yy1)/(y2-y1)+yy1,'b-.','linewidth',2);

x=out_NIHT{1}.tVec(:); y=out_NIHT{1}.likelihood(:);
idx=find((x>=x1)&(x<x2)&(y>=y1)&(y<y2));
plot((x(idx)-x1)*(xx2-xx1)/(x2-x1)+xx1,(y(idx)-y1)*(yy2-yy1)/(y2-y1)+yy1,'r--','linewidth',2);

x=out_NIHT{2}.tVec(:); y=out_NIHT{2}.likelihood(:);
idx=find((x>=x1)&(x<x2)&(y>=y1)&(y<y2));
plot((x(idx)-x1)*(xx2-xx1)/(x2-x1)+xx1,(y(idx)-y1)*(yy2-yy1)/(y2-y1)+yy1,'r:','linewidth',2);

type='k:';
lw=1;
plot([x1 x2],[y1 y1],type,'linewidth',lw);
plot([x1 x2],[y2 y2],type,'linewidth',lw);
plot([x1 x1],[y1 y2],type,'linewidth',lw);
plot([x2 x2],[y1 y2],type,'linewidth',lw);

plot([xx1 xx2],[yy1 yy1],type,'linewidth',lw);
plot([xx1 xx2],[yy2 yy2],type,'linewidth',lw);
plot([xx1 xx1],[yy1 yy2],type,'linewidth',lw);
plot([xx2 xx2],[yy1 yy2],type,'linewidth',lw);

plot([x1 xx1],[y1 yy1],type,'linewidth',lw);
plot([x2 xx2],[y2 yy2],type,'linewidth',lw);

saveas(gcf,'cut20Likelihood.eps','psc2');
close all
