function x = FBPFunc3(y,f,st,m,Ts,maskIdx)
% x: wavelet coefficients vector
% y: the input projection data in frequency domain
% f: coefficients of the filter applying on y
% st: 
% h: wavelet scaling filter
% L: level of wavelet decomposition
% m: size of image

Num_proj=st.Num_proj;
N=length(y);
n=(N)/2-Num_proj;
y(Num_proj*2+1:end-n)=(y(Num_proj*2+1:end-n)+1i*y(end-n+1:end))/sqrt(2);
y(1:end-n)=y(1:end-n).*f;
y(end-n+1:end)=conj(y(Num_proj*2+1:end-n));
x=nufft_adj(y(:),st)*pi/Ts/st.M;
if(nargin==5)
    x=real(x(:));
else
    x=real(x(maskIdx));
end
%x=x/sqrt(pi/(2*Ts^3*Num_proj*st.Num_pixel));

