function y = PhiFunc31(x,f,st,m,Ts,maskIdx)
% y: the output measurements
% x: the input wavelet coefficients vector
% f: coefficients of the filter applying on y
% st: 
% h: wavelet scaling filter
% L: level of wavelet decomposition
% m: size of image

% Ts: The interval of pixels of the input image
% Author: Renliang Gu (renliang@iastate.edu)
% Date: Mon Nov  7 12:57:01 CST 2011

Num_proj=st.Num_proj;
if(nargin>5)
    u=zeros(m,m);
    u(maskIdx)=x;
else
    u=reshape(x,m,m);
end
y=nufft(u,st)*Ts^2;
N=length(y);
n=(N)/2-Num_proj;
y(Num_proj*2+n+1:end)=sqrt(2)*imag(y(Num_proj*2+1:end-n));
y(Num_proj*2+1:end-n)=sqrt(2)*real(y(Num_proj*2+1:end-n));
y=real(y);
%y=y*sqrt(pi/(2*Ts^3*Num_proj*st.Num_pixel));
