function x = PhitFunc31(y,f,st,m,Ts,maskIdx)
% x: wavelet coefficients vector
% y: the input projection data in frequency domain
% f: coefficients of the filter applying on y
% st: 
% h: wavelet scaling filter
% L: level of wavelet decomposition
% m: size of image

% Ts: The interval of pixels of the input image (put here to make sure the 
% image is in the right scale, and ease debugging)
% Author: Renliang Gu (renliang@iastate.edu)
% Date: Mon Nov  7 12:57:01 CST 2011

Num_proj=st.Num_proj;
N=length(y);
n=(N)/2-Num_proj;
y(Num_proj*2+1:end-n)=(y(Num_proj*2+1:end-n)+1i*y(end-n+1:end))/sqrt(2);
y(end-n+1:end)=conj(y(Num_proj*2+1:end-n));
x=nufft_adj(y(:),st)*Ts^2;
if(nargin==5)
    x=real(x(:));
else
    x=real(x(maskIdx));
end
% x=x*sqrt(pi/(2*Ts^3*Num_proj*st.Num_pixel)); % to normalize the Phi*Phit
